# Distribution Checker
# Manual Xpdf Test Module (Xpdf_manual_test.pm)
#
# Copyright (C) 2007-2009 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
# The ptyshell tool is originally written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2007 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

package Xpdf_manual_test;
use strict;
use Misc;

use Manual_test;
our @ISA = qw(Manual_test); # Inherit Manual_test
#----------------------------------------------------------------------

sub prepare {
	my ($self) = @_;

	# Call the parent's prepare function
	is_ok $self->Manual_test::prepare() or return $Error::Last;

	my $tmp_xpdf_dir = '/tmp/lsb-xpdf-tests';
	$Error::Last = undef;
	if ( -d $tmp_xpdf_dir ) {
		if ( cmd('rm -rf '.shq($tmp_xpdf_dir)) != 0 ) {
			$Error::Last = error($last_cmd_output);
		}
	}
	mkdir($tmp_xpdf_dir) or $Error::Last = error($!);
	( -d $tmp_xpdf_dir ) or return error "Failed to prepare directory '$tmp_xpdf_dir'", $Error::Last;

	is_ok $self->copy_files_from_reqs_to($tmp_xpdf_dir) or return $Error::Last;
	
	( -f $tmp_xpdf_dir."/test1.pdf" && -f $tmp_xpdf_dir."/test2.pdf" )
		or fail "Failed to copy test files. Please contact [lsb-dtk-support\@linuxbase.org].";

	return 1;
}

1; # return value
