#!/usr/bin/perl -w

# Distribution Checker
# Administration Page Module (tests_admin.pl)
#
# Copyright (C) 2007-2009 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
# The ptyshell tool is originally written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2007 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use TestStatus;

print "HTTP/1.0 200 OK" . CRLF;
print "Content-type: text/html" . CRLF . CRLF;

print_header("$DC_BRANCH Distribution Checker Administration", 'admin');

print "<h1>$DC_BRANCH Distribution Checker Administration</h1>\n";

my $error_text = '';

my $log_file = "$SERVER_PARAM{'APP_DATA'}/log/dc-server.log.$SERVER_PARAM{'PORT'}";
my $serv_pid = $SERVER_PARAM{'SERVER_PID'};

my $serv_status;
my $serv_stop_button;
if ($serv_pid) {
	$serv_status = "<font color=\"green\">Running</font> (PID: $serv_pid)";
	$serv_stop_button = " onclick=\"javascript:onStopServer($serv_pid, 'server');\"";
}
else {
	$serv_status = '<b><font color="red">PID not found!</font></b>';
	$serv_stop_button = ' disabled="disabled"';
}

my $test_status;
my $test_stop_button;
my $running = 0;
if (lock_status()) {
	my $status = read_status();
	$running = $status->{'IS_RUNNING'};
	if ($running) {
		$test_status = "<font color=\"green\">Running</font> (PID: $status->{'PID'})";
		$test_stop_button = " onclick=\"javascript:onStopServer($status->{'PID'}, 'tests');\"";
	}
	else {
		$test_status = '<font color="red">Not running</font>';
		$test_stop_button = ' disabled="disabled"';
	}
	unlock_status();
}
else {
	$error_text = "Error locking the status file!<br />$status_error";
	$test_status = '<b><font color="red">PID not found!</font></b>';
	$test_stop_button = ' disabled="disabled"';
}

print show_error_dlg($error_text);

my @proxy_auth_modes = (
	{'ID' => 'basic', 'NAME' => 'Basic'},
	{'ID' => 'digest', 'NAME' => 'Digest'},
	{'ID' => 'ntlm', 'NAME' => 'NTLM'},
	{'ID' => 'negotiate', 'NAME' => 'GSS-Negotiate'},
	{'ID' => 'anyauth', 'NAME' => 'Autoselect'},
);

print <<DATA;
<div id="ajax_loading" style="display: none; position: fixed; width: 13em; height: 5.8em; top: 40%; left: 50%; margin-top: -2.9em; margin-left: -7.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; padding: 6px;"><div align="center">
Please wait&hellip;<br />
<img src="images/environment-spacer.gif" width="1" height="5" alt="" /><br />
<img src="images/ajax_progress.gif" width="16" height="16" alt="" /><br />
<img src="images/environment-spacer.gif" width="1" height="7" alt="" /><br />
<input type="button" name="ajax_abort" id="ajax_abort" value="Abort" style="border: solid 1px #00007f; background: #e0e0ff; color: blue; width: 6em;" onclick="javascript:onAbort();" />
</div></div>

<div id="disable_layer" style="display: none; position: fixed; width: 100%; height: 100%; top: 0px; left: 0px; background-color: gray; opacity: 0.4; filter: alpha(opacity=40);"></div>

<table cellpadding="0" cellspacing="0" id="server_stopped" style="display: none; position: fixed; width: 25em; height: 6em; top: 40%; left: 50%; margin-top: -3em; margin-left: -12.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; vertical-align: middle; padding: 6px;"><tr><td>
<font size="+2" color="red"><b>Server is stopped</b></font>
</td></tr></table>

<table cellpadding="0" cellspacing="0" border="0" style="width: 50em;">
  <tr>
    <td valign="top" width="100%">
      <table cellpadding="0" cellspacing="0" border="0" width="100%">
        <tr>
          <td style="border: solid 1px #606090; background: #e0e0ff; text-align: center; font-size: large; padding: 0.3em;">Status</td>
        </tr>
        <tr>
          <td style="border: solid 1px #606090; border-top: none; vertical-align: top; padding: 10px;">
            <table class="main" cellpadding="2" cellspacing="2">
              <tr>
                <td style="width: 8em;">Server status:</td>
                <td style="width: 12.5em;" id="server_status">$serv_status</td>
                <td><input type="button" id="server_stop" style="width: 7.5em;" value="Stop server"$serv_stop_button /></td>
              </tr>
              <tr>
                <td>Tests status:</td>
                <td id="tests_status">$test_status</td>
                <td><input type="button" id="tests_stop" style="width: 7.5em;" value="Stop tests"$test_stop_button /></td>
              </tr>
            </table>
            <br />
            <a href="/get.pl$log_file" target="_blank">View server log</a>
          </td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td><img src="images/environment-spacer.gif" width="1" height="20" border="0" alt="" /></td>
  </tr>
  <tr>
    <td valign="top" width="100%">
      <form name="server_config" id="server_config" method="post" action="">
        <table cellpadding="0" cellspacing="0" border="0" width="100%">
          <tr>
            <td style="border: solid 1px #606090; background: #e0e0ff; text-align: center; font-size: large; padding: 0.3em;">Server Configuration</td>
          </tr>
          <tr>
            <td style="border: solid 1px #606090; border-top: none; vertical-align: top; padding: 10px;">
              Proxy servers for connecting to the Linux Foundation servers:<br />
              <table cellpadding="2" cellspacing="0" border="0" style="margin-top: 0.3em;">
DATA

my $same_proxy_sel = '';
if ($SERVER_PARAM{'PROXY'} or (!$SERVER_PARAM{'PROXY'} and !$SERVER_PARAM{'HTTP_PROXY'} and !$SERVER_PARAM{'FTP_PROXY'})) {
	$same_proxy_sel = ' checked="checked"';
}

print <<DATA;
                <tr>
                  <td colspan="3"><label><input type="checkbox" name="same_proxy_config" id="same_proxy_config"$same_proxy_sel onclick="javascript:onSameProxy();" /> Use one configuration for both HTTP and FTP</label></td>
                </tr>
DATA

foreach my $proto (qw/http ftp/) {
	my $proto_name = uc($proto);
	my ($user, $pswd, $host, $port) = ('', '', '', '');
	my ($user_style, $pswd_style, $host_style, $port_style) = (' display: none;', ' display: none;', ' display: none;', ' display: none;');
	my ($user_hstyle, $pswd_hstyle, $host_hstyle, $port_hstyle) = ('', '', '', '');
	my $pswd_wstyle = ' display: none;';
	if ($SERVER_PARAM{$proto_name.'_PROXY'} =~ m/^(?:([A-Za-z0-9\-_.\@]+)(?::(.*))?\@)?([A-Za-z0-9\-_.]+):(\d+)$/) {
		if ($1) {
			$user = $1;
			$user_style = '';
			$user_hstyle = ' display: none;';
		}
		if ($2) {
			$pswd = $2;
			$pswd_style = '';
			$pswd_hstyle = ' display: none;';
			$pswd_wstyle = '';
		}
		if ($3) {
			$host = $3;
			$host_style = '';
			$host_hstyle = ' display: none;';
		}
		if ($4) {
			$port = $4;
			$port_style = '';
			$port_hstyle = ' display: none;';
		}
	}

	print <<DATA;
                <tr>
                  <td rowspan="3" id="${proto}_title" style="vertical-align: top; font-weight: bold; width: 4em; height: 2em;">$proto_name:</td>
                  <td colspan="2"><input type="text" name="${proto}_proxy_host" id="${proto}_proxy_host" value="$host" style="width: 20em; height: 1.2em;$host_style" /><input type="text" name="${proto}_proxy_host_hint" id="${proto}_proxy_host_hint" value="hostname" style="width: 20em; height: 1.2em; color: #a0a0a0; font-style: italic;$host_hstyle" onfocus="javascript:hideHint(this, '${proto}_proxy_host');" /> <input type="text" name="${proto}_proxy_port" id="${proto}_proxy_port" value="$port" style="width: 5em; height: 1.2em;$port_style" /><input type="text" name="${proto}_proxy_port_hint" id="${proto}_proxy_port_hint" value="port" style="width: 5em; height: 1.2em; color: #a0a0a0; font-style: italic;$port_hstyle" onfocus="javascript:hideHint(this, '${proto}_proxy_port');" /></td>
                </tr>
                <tr>
                  <td rowspan="2" id="${proto}_auth_title" style="vertical-align: top; height: 2em;">Authentication:</td>
                  <td>
                    <select name="${proto}_proxy_auth" id="${proto}_proxy_auth" style="width: 13em;">
DATA

	my ($proxy_auth, $proxy_auth_notunnel) = split(/,/, $SERVER_PARAM{$proto_name.'_PROXY_AUTH'});
	foreach my $auth_mode (@proxy_auth_modes) {
		if ($auth_mode->{'ID'} eq $proxy_auth) {
			print "                      <option value=\"$auth_mode->{'ID'}\" selected=\"selected\">$auth_mode->{'NAME'}</option>\n";
		}
		else {
			print "                      <option value=\"$auth_mode->{'ID'}\">$auth_mode->{'NAME'}</option>\n";
		}
	}
	my $proxy_auth_notunnel_sel = (($proxy_auth_notunnel and ($proxy_auth_notunnel eq 'notunnel')) ? ' checked="checked"' : '');

	print <<DATA;
                    </select>
                    <label><input type="checkbox" name="${proto}_proxy_auth_notunnel" id="${proto}_proxy_auth_notunnel"$proxy_auth_notunnel_sel /> <span id="${proto}_auth_notunnel_title">No tunnelling</span></label>
                  </td>
                </tr>
                <tr>
                  <td style="height: 2em;"><input type="text" name="${proto}_proxy_user" id="${proto}_proxy_user" value="$user" style="width: 7em; height: 1.2em;$user_style" /><input type="text" name="${proto}_proxy_user_hint" id="${proto}_proxy_user_hint" value="username" style="width: 7em; height: 1.2em; color: #a0a0a0; font-style: italic;$user_hstyle" onfocus="javascript:hideHint(this, '${proto}_proxy_user');" /> <input type="password" name="${proto}_proxy_pswd" id="${proto}_proxy_pswd" value="$pswd" style="width: 7em; height: 1.2em;$pswd_style" onchange="javascript:controlPasswordWarning('$proto');" onkeyup="javascript:controlPasswordWarning('$proto');" /><input type="text" name="${proto}_proxy_pswd_hint" id="${proto}_proxy_pswd_hint" value="password" style="width: 7em; height: 1.2em; color: #a0a0a0; font-style: italic;$pswd_hstyle" onfocus="javascript:hideHint(this, '${proto}_proxy_pswd');" /><img src="images/environment-spacer.gif" alt="" style="width: 0.7em; height: 1.0em;" /><a href="tests_help.pl#password_insecure" target="_blank" id="${proto}_proxy_pswd_warning" style="color: red; text-decoration: underline;$pswd_wstyle">Storing the password is insecure!</a></td>
                </tr>
                <tr>
                  <td><img src="images/environment-spacer.gif" alt="" width="1" height="10" /></td>
                </tr>
DATA

}

print <<DATA;
              </table>
              <br />
              <input type="button" name="apply_button" id="apply_button" value="Apply" style="width: 7em;" onclick="javascript:onSettingsApply();" />&nbsp;&nbsp;&nbsp;<input type="button" name="clear_button" id="clear_button" value="Clear" style="width: 7em;" onclick="javascript:onSettingsClear();" /><span id="conf_saved_msg" style="display: none;">&nbsp;&nbsp;&nbsp;<b>Configuration saved</b></span>
            </td>
          </tr>
        </table>
      </form>
    </td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
// Preload some images that are not initially visible
preload_images(new Array('expand.png', 'collapse.png', 'ajax_progress.gif'));
var input_border_color = ((navigator.appName == 'Konqueror') ? '#cccccc' : '');

// Work with "hint-boxes" (text boxes with "ghost" hint text inside)
function hideHint(hint_elem, id) {
	var elem = document.getElementById(id);
	if (!elem)
		return;
	hint_elem.style.display = 'none';
	elem.style.display = '';
	// Konqueror cannot set focus immediately for unknown reason. Oh, well, give him some time to think...
	setTimeout('document.getElementById(\\'' + id + '\\').focus()', 10);
}

var saved_control_values = new Array();

function onSameProxy() {
	var elem = document.getElementById('same_proxy_config');
	if (!elem)
		return;
	var make_disabled = elem.checked;
	// TODO: Get rid of plain enumeration (?)
	var gray_out = new Array('ftp_title', 'ftp_auth_title', 'ftp_auth_notunnel_title');
	var disable = new Array('ftp_proxy_host', 'ftp_proxy_port', 'ftp_proxy_auth', 'ftp_proxy_auth_notunnel', 'ftp_proxy_user', 'ftp_proxy_pswd');
	for (var i in gray_out) {
		document.getElementById(gray_out[i]).style.color = (make_disabled ? 'gray' : 'black');
	}
	for (var i in disable) {
		var id = disable[i];
		elem = document.getElementById(id);
		if (elem) {
			elem.disabled = make_disabled;
			if (make_disabled) {
				saved_control_values[id] = elem.value;
				elem.value = '';
			}
			else {
				elem.value = saved_control_values[id];
			}
		}
		var id_hint = id + '_hint';
		elem = document.getElementById(id_hint);
		if (elem) {
			elem.disabled = make_disabled;
			if (make_disabled) {
				saved_control_values[id_hint] = elem.value;
				elem.value = '';
			}
			else {
				elem.value = saved_control_values[id_hint];
			}
		}
	}
	controlPasswordWarning('ftp');
}

function controlPasswordWarning(proto) {
	var pswd = document.getElementById(proto + '_proxy_pswd');
	document.getElementById(proto + '_proxy_pswd_warning').style.display = ((pswd.value == '') ? 'none' : '');
}

DATA

print "onSameProxy();\n\n" if ($same_proxy_sel);

print <<DATA;
// AJAX
function onStopServer(pid, what) {
	if (!ajax_req_busy) {
		if (confirm('Do you really want to kill the process tree (PID: ' + pid + ')?')) {
			ajax_call_get('action=stop_tests&tree=' + what);
		}
	}
}

function onSettingsApply() {
	if (!ajax_req_busy) {
		ajax_call_post('action=server_control', 'server_config');
	}
}

function onSettingsClear() {
	if (confirm('Are you sure you want to clear the settings?')) {
		var protocols = ['http_', 'ftp_'];
		for (var i in protocols) {
			var prefix = protocols[i];
			var elem;
			elem = document.getElementById(prefix + 'proxy_auth');
			if (elem)
				elem.value = 'basic';
			elem = document.getElementById(prefix + 'proxy_auth_notunnel');
			if (elem)
				elem.checked = false;
			var to_clear = new Array('proxy_host', 'proxy_port', 'proxy_user', 'proxy_pswd');
			for (var j in to_clear) {
				elem = document.getElementById(prefix + to_clear[j]);
				if (elem)
					elem.value = '';
			}
		}
	}
}

function ajaxProcessResult(responseXML) {
	if (responseXML.getElementsByTagName('stopped').length > 0) {
		var stopped = responseXML.getElementsByTagName('stopped')[0].childNodes[0].nodeValue;
		var what = responseXML.getElementsByTagName('stopped')[0].getAttribute('id');
		var server_status = document.getElementById('server_status');
		var server_stop = document.getElementById('server_stop');
		var tests_status = document.getElementById('tests_status');
		var tests_stop = document.getElementById('tests_stop');
		if (server_status && server_stop && tests_status && tests_stop) {
			if (what == 'tests') {
				tests_status.innerHTML = '<font color="red">Not running</font>';
				tests_stop.disabled = true;
			}
			else if (what == 'server') {
				server_status.innerHTML = '<font color="red">Not running</font>';
				server_stop.disabled = true;
				tests_status.innerHTML = '<font color="red">Not running</font>';
				tests_stop.disabled = true;
				var server_stopped = document.getElementById('server_stopped');
				server_stopped.style.display = '';
				var show_disable_layer = true;
				if (navigator.appName == 'Konqueror') {
					show_disable_layer = false;
				}
				else if (navigator.appName == 'Microsoft Internet Explorer') {
					var idx = navigator.appVersion.indexOf('MSIE ');
					if (idx == -1) {
						show_disable_layer = false;
					}
					else {
						if (navigator.appVersion.substr(idx + 5, 1) < '7')
							show_disable_layer = false;
					}
				}
				if (show_disable_layer)
					document.getElementById('disable_layer').style.display = '';
			}
		}
	}
	else if (responseXML.getElementsByTagName('serverupd').length > 0) {
		new fadeOut('conf_saved_msg', 0, 128, 0, 255, 255, 255, true);
	}
}
// ]]>
</script>
DATA

print_footer();
