#!/usr/bin/perl -w

# Distribution Checker
# Configuration Save Module (tests_conf_save.pl)
#
# Copyright (C) 2007-2009 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
# The ptyshell tool is originally written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2007 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use UserProfile;
use TestStatus;
use Common;

my $conf_page = ($_POST{'certify'} ? 'tests_cert.pl' : 'tests_conf.pl');
if ($_GET{'goto'}) {
	$conf_page = $_GET{'goto'};
	$conf_page =~ s/%23/#/;
	$_POST{'form_action'} = '';
}
my $session_profile = ($_COOKIE{'session_id'} ? '~session.'.$SERVER_PARAM{'PEER_IP'}.'.'.$_COOKIE{'session_id'} : '');

my $error;
my $new_url = '';
my $save_profile_name = '';
my @cookies = ();

if (!-d $SERVER_PARAM{'APP_DATA'}.'/profiles') {
	system('mkdir -p '.$SERVER_PARAM{'APP_DATA'}.'/profiles');
	if (!-d $SERVER_PARAM{'APP_DATA'}.'/profiles') {
		$error = '';
	}
}

if (!defined($error)) {
	if ((!$_POST{'form_action'} or ($_POST{'form_action'} eq '')) and (!$_GET{'goto'})) {
		$error = 'Script action not specified!';
	}
	elsif ($_POST{'form_action'} eq 'run_tests') {
		if ($session_profile eq '') {
			$error = 'Cannot retrieve session ID! Please, allow cookies in your browser.';
		}
		else {
			$new_url = 'tests_exec.pl';
			push @cookies, "profile=$session_profile";
			$save_profile_name = $session_profile;
		}
	}
	elsif ($_GET{'goto'}) {
		$save_profile_name = $session_profile;
		$new_url = $conf_page;
	}
}

if ($save_profile_name ne '') {
	my $full_save_name = $SERVER_PARAM{'APP_DATA'}."/profiles/$save_profile_name";
	if (!write_profile($full_save_name, \%_POST)) {
		$error = $profile_error if (!defined($error));
	}
}

if (defined($error)) {
	$error = escape($error);
	print "HTTP/1.0 302 Moved" . CRLF;
	print "Set-Cookie: last_error_text=$error; path=/;" . CRLF;
	print "Location: $conf_page" . CRLF . CRLF;
}
else {
	print "HTTP/1.0 302 Moved" . CRLF;
	print "Location: $new_url" . CRLF;
	foreach (@cookies) {
		print "Set-Cookie: $_; path=/;" . CRLF;
	}
	print CRLF;
}
