#!/usr/bin/perl -w

# Distribution Checker
# Help Page Module (tests_help.pl)
#
# Copyright (C) 2007-2009 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
# The ptyshell tool is originally written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2007 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;

print "HTTP/1.0 200 OK" . CRLF;
print "Content-type: text/html" . CRLF . CRLF;

print_header("Information", "help");

print <<DATA;
<a name="top"></a>
<p align="justify"><b>$DC_BRANCH Distribution Checker</b> provides a web interface for executing $DC_BRANCH tests.</p><br />
<table style="border: dashed 1px #2f6fab; padding: 5px; white-space: nowrap; background-color: #f9f9f9;"><tr><td>
<h3>Help Contents</h3>
<ol>
  <li><a href="#get_cert">Get&nbsp;Certified page</a></li>
  <li><a href="#conf">Custom&nbsp;Tests page</a></li>
  <li><a href="#exec">Execution page</a></li>
  <li><a href="#manappbat">Manual Tests page</a></li>
  <li><a href="#results">Results page</a>
    <ul>
      <li><a href="#sumreport">Summary Report page</a></li>
      <li><a href="#detreport">Detailed Report page</a></li>
    </ul>
  </li>
  <li><a href="#help">Help page</a></li>
  <li><a href="#about">About page</a></li>
  <li><a href="#admin">Administration page</a></li>
  <li><a href="#troubleshooting">Troubleshooting</a></li>
</ol></td></tr>
</table>
<br />

<a name="get_cert"></a><h1>Get&nbsp;Certified</h1>
<p align="justify">
Open this page to start normal $DC_BRANCH certification. This page is very similar to the <a href="#conf"><b>Custom&nbsp;Tests</b></a> page, but has some restrictions implied by the certification process:
</p>
<ul>
  <li>The <b>Your name</b> and <b>Organization</b> fields are mandatory.</li>
  <li>It is impossible to turn off using Internet: all the test packages must be downloaded by the $DC_BRANCH Distribution Checker if they are not available locally.</li>
  <li>It is impossible to use short scenarios.</li>
  <li>The test selection list is turned off (the most recent versions of all the necessary tests are executed).</li>
  <li>The additional option <b>Profile</b> allows to test against different $DC_BRANCH profiles (it is not needed for the <a href="#conf"><b>Custom&nbsp;Tests</b></a> page as there are more flexible settings available).</li>
</ul>
<p align="right"><a href="#top">Back to top</a></p>

<a name="conf"></a><h1>Custom&nbsp;Tests</h1>
<p align="justify">
This page allows you to configure the test system. The following options are present:
</p>
<ul>
  <li><b>Your name:</b><br />The name of the user who started the tests.</li>
  <li><b>Organization:</b><br />The name of your organization.</li>
  <li><b>E-mail:</b><br />Specify your E-mail here. It will be used for sending the report after the tests finish.</li>
  <li><b>Send report via E-mail</b><br />Choose whether to send the report via E-mail using the specified address. Make sure that your Mail Transfer Agent is customized properly.<br />Please note that the all the journals are packed and attached to this mail, so its size may be up to 4 MB or even larger.</li>
  <li><b>Additional options</b><br />Less important additional settings are shown here. To show/hide them just click the orange header. This block contains the following settings:
    <ul>
      <li><b>Verbose Level:</b><br />Specifies how much information should be given by the tests to the output console.</li>
      <li><b>Comments:</b><br />Here you may write comments with any additional information. These comments are stored in the execution report and shown in the <a href="#results"><b>Results</b></a> page.</li>
    </ul>
  </li>
  <li><b>Use Internet for downloading the tests</b><br />This checkbox allows you to specify not to use any Internet connections for downloading the test packages. If it is turned off, you will not be able to refresh the list of the tests.</li>
  <li><b>Architecture:</b><br />Select the machine architecture here. NOTE: Only architectures that are compatible with the machine being tested are listed.</li>
  <li><b>Standard:</b><br />This combobox specifies the standard to check against.</li>
  <li><b>Refresh List</b><br />This button causes the $DC_BRANCH Distribution Checker to connect to the <a href="ftp://linuxfoundation.org/" target="_blank">LF&rsquo;s FTP server</a>, obtain the list of the latest test packages, and update the list of packages shown below based on downloaded and newly available packages.</li>
</ul>
<p align="justify">
Below is the list of available test packages present. It is stored locally, so it is not guaranteed that the list contains the latest information about test suite versions. To update the list, press the <b>Refresh List</b> button. If the list is more than a week old, a warning is displayed that the list may be outdated.
</p>
<p align="justify">
The list of test suites consists of four columns.
</p>
<ol>
  <li><b>Test Suite</b><br />This column contains the name of the test suite and a checkbox indicating whether to execute this test or not. If the test supports several profiles, an option for selecting the profile is also present.</li>
  <li><b>Version</b><br />Here the selected version of the test suite is displayed. If you click the version number, a dialog is shown that allows to select another version of the test (if available). The status of each test version is indicated with the icon to the left:
    <ul>
      <li><img src="images/status_cert.png" width="16" height="16" alt="" /> The version used for official certification.</li>
      <li><img src="images/status_certold.png" width="16" height="16" alt="" /> Old version which is still possible to pass certification with, though not recommended.</li>
      <li><img src="images/status_noncert.png" width="16" height="16" alt="" /> A stable test version which is not applicable for certification for some reason (e.g. too outdated).</li>
      <li><img src="images/status_beta.png" width="16" height="16" alt="" /> Beta version of the test suite.</li>
      <li><img src="images/status_snapshot.png" width="16" height="16" alt="" /> Snapshot version of the test suite.</li>
    </ul>
    By clicking the column title you can open a dialog for quickly selecting the latest versions for all tests (e.g. to select all the latest snapshot versions).
  </li>
  <li><b>Files</b><br />By clicking the gear icon in this column you can open a dialog for fine-tuning the installation process: downloading and installing the specific files the test suite consists of.</li>
  <li><b>Advanced</b><br />If the test suite supports additional customization, its options can be adjusted here. Click the icon in this column, and a dialog is opened which contains the list of options for the specific test suite.</li>
</ol>
<p align="justify">
When you select the tests, you can see the approximate summary size of the packages to be downloaded (in the <b>Download size:</b> field just above the list of the tests). If you turn the option <b>Use Internet connection for downloading the tests</b> off, all test packages which need downloading will be highlighted with red to indicate that the test will be impossible to launch.
</p>
<p align="justify">
After you selected the test packages to run you may press the button <b>Run selected tests</b> located at the bottom of the page. This will redirect you immediately to the next page (<a href="#exec"><b>Execution</b></a>) and the tests will start. If the tests are already (or still) running you will get the error message at the top of the page, because it is currently impossible to run several tests instances simultaneously.
</p>

<a name="profile_management"></a><h3>User Profile Management</h3>
<p align="justify">
This section allows you to save/load all the settings listed above in different user profile files. To save the settings just specify the new profile name in the edit box (or use the drop-down list to select the existing profile and overwrite it), and then press the <b>Save</b> button. To load a previously saved profile, select it from the drop-down list and press <b>Load</b>. The <b>Delete</b> button allows you to delete the old profiles that are no longer needed.<br />
<b>Note:</b> The profile is not automatically saved when you run the tests! The settings are just stored in a temporary <i>session profile</i> which is automatically removed when it is no longer used. So if you wish to use the same set of options later, please save it explicitly, via the <b>Save</b> button.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="exec"></a><h1>Execution</h1>
<p align="justify">
This page allows you to watch the tests execution progress. If the tests are already running, you may open this page to watch the progress (even from another computer). If the tests are not running at the moment, you may select the user profile that was saved earlier on the <a href="#conf"><b>Custom&nbsp;Tests</b></a> or <a href="#cert"><b>Get&nbsp;Certified</b></a> page and run the tests by pressing the <b>Start</b> button. The <b>Stop</b> button allows you to forcibly stop the tests execution.
</p>
<p align="justify">
Just below, the current status of the tests execution and its output console are shown. The console is refreshed automatically about every second and displays all output for the tests (both <b>stdout</b> and <b>stderr</b>). To the right a table with the list of selected tests is displayed with current status for each test. After the correct completion of the tests you are automatically redirected to the <a href="#sumreport"><b>Summary Report</b></a> page with the results of the tests just finished. You can then continue with manual tests if necessary (see below).
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="manappbat"></a><h1>Manual Tests page</h1>
<p align="justify">
This page allows you to perform manual tests. You can open it from the <a href="#results"><b>Results</b></a> page or from the intermediate <a href="#sumreport"><b>Summary Report</b></a> page.
</p>
<p align="justify">
The left pane contains the full list of all the manual tests (it depends on the standard version and test suites selected). To perform the particular test you can click the name of the test in the left column of the table. To the right from the test name its status is shown:
</p>
<ul>
  <li><b><font color="blue">Not finished</font></b>: The test was not performed yet.</li>
  <li><b><font color="gray">Skipped</font></b>: The test was skipped.</li>
  <li><b><font color="green">Passed</font></b>: The test was performed without problems.</li>
  <li><b><font color="#c0a000">Warnings</font></b>: The test was performed with some non-critical problems.</li>
  <li><b><font color="red">Failed</font></b>: The test was performed with some serious problems.</li>
</ul>
<p align="justify">
When all the tests are performed, the <b>Finish</b> button located below the table becomes active. When you press it, the new reports are generated and you are redirected to the updated <a href="#sumreport"><b>Summary Report</b></a> page.
</p>
<p align="justify">
The right pane contains the steps of the test selected. Each test is a set of "yes-no" questions usually containing the description of the step to be performed and the result expected. You need to perform all the steps and answer if you got the expected results.  After you answered all the questions and (optionally) wrote additional comments, press the <b>Finish test</b> button. Your answers are then saved to the journal and the next test is opened automatically. Also you can skip the current test by pressing the <b>Skip test</b> button.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="results"></a><h1>Results</h1>
<p align="justify">
This page shows the table with the full list of the tests execution results. The table contains the following columns:
</p>
<ul>
  <li><b>Date/Time</b><br />Here the date and time are shown, when the tests were finished. At the left edge of this column a status-icon is shown:
    <ul>
      <li><img src="images/CertPassed.png" alt="CertPass" width="33" height="30" /> The certification tests passed.</li>
      <li><img src="images/CertFailed.png" alt="CertFail" width="33" height="30" /> The certification tests failed.</li>
      <li><img src="images/TestsPassed.png" alt="TestsPassed" width="33" height="30" /> The custom set of tests passed.</li>
      <li><img src="images/TestsFailed.png" alt="TestsFailed" width="33" height="30" /> The custom set of tests failed.</li>
    </ul>
    The translucent status icon means that the manual tests were selected for this test run (either explicitly or implicitly) but were not performed yet. In this case the "<i>passed</i>" or "<i>failed</i>" status applies to the automatic tests that have already been finished.<br />
    In the cell&rsquo;s right-bottom corner there are several additional icons:
    <ul>
      <li><img src="images/run_manual.png" alt="" width="16" height="16" /> This icon is present only when manual tests were not finished yet. Clicking on it redirects you to the <a href="#manappbat"><b>Manual Tests</b></a> page.</li>
      <li><img src="images/report_details.gif" alt="" width="16" height="16" /> Clicking on this icon opens the <a href="#detreport"><b>Detailed Report</b></a> page for this test run.</li>
      <li><img src="images/report_summary.gif" alt="" width="16" height="16" /> Clicking on this icon opens the <a href="#sumreport"><b>Summary Report</b></a> page for this test run (clicking the date/time link does the same).</li>
    </ul>
  </li>
  <li><b>Summary</b><br />This column shows the general results of the tests (how many tests passed and failed).</li>
  <li><b>Comment</b><br />Here the comments entered on the <a href="#conf"><b>Custom&nbsp;Tests</b></a> or <a href="#cert"><b>Get&nbsp;Certified</b></a> page are shown.</li>
</ul>
<p align="justify">
To remove the reports that are no longer needed, just mark them with the checkboxes shown at the left edge of the corresponding lines and press the <b>Remove Selected Entries</b> button.
</p>
<p align="justify">
To compare results of several test runs, mark them with the checkboxes shown and press the <b>Compare Selected Entries</b> button.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="sumreport"></a><h2>Summary Report page</h2>
<p align="justify">
This page shows the summary status of the automatic and manual tests:
</p>
<ul>
  <li><b>PASSED</b> means that the tests have been passed.</li>
  <li><b>FAILED</b> means that there were some problems.</li>
  <li><b>NOT SELECTED</b> is shown when you selected no manual tests, only automatic ones (or vice versa).</li>
  <li><b>NOT FINISHED YET</b> can be shown for the manual tests only. It means that you did not perform the manual tests yet.</li>
  <!--li><b>NOT REQUIRED</b> is shown for manual tests when a certification test run was performed that did not require manual tests (<b>Core &amp; C++</b> profile).</li-->
</ul>
<p align="justify">
If the manual tests are not performed you can run them by clicking the <b>NOT FINISHED YET</b> status text in the table.
</p>
<p align="justify">
Below the table additional information is shown, depending on the tests selected and their status. Generally, you can find there what to do with failing tests, how to apply for certification, where to find the journal files and how to return back to this page after closing it.
</p>
DATA

if ($DC_BRANCH eq 'LSB') {
	print <<DATA;
<p align="justify">
There is also a link <b>Apply for certification</b> which allows you submitting
the results to the <a href="http://$cert_sys_host$cert_sys_base" target="_blank">Certification System</a>.<br />
<b>Note:</b> you can apply for certification with results of a <b>certification</b> test run only.
For custom test results there is the <b>Upload the test results</b> link instead which allows you to upload additional results (if needed) for a product already being certified.
</p>
DATA
}

print <<DATA;
<p align="right"><a href="#top">Back to top</a></p>

<a name="detreport"></a><h2>Detailed Report page</h2>
<p align="justify">
This page contains the detailed report about the test results. It consists of the following sections:
</p>
<ul>
  <li>
    <b>Test info</b><br />
    Contains the information about the machine where the tests were executed.
  </li>
  <li>
    <b>Tests executed</b><br />
    An index with links to details and a short summary for each test.<br />
    <a name="No_result"></a>If <b>No result</b> is shown for an automatic test, this means that the test failed to run or was interrupted during the execution.
  </li>
  <li>
    <b>Details for each test</b><br />
    Here the information from the test journal is shown, including the list of warnings and errors detected. You may click any line with particular problem to see more details about this problem. The <b>Severity</b> column contains the status of the problem. Here are the descriptions for some of the status messages:
    <ul>
      <li><b>Warning</b> means that this some non-critical problem occurred.</li>
      <li><b>Failed</b> means that a severe problem occurred (it usually implies that the distribution is not compliant).</li>
      <li><a name="FIP"></a><b>FIP</b> stands for "<i>Further Information Provided</i>". These FIP results occur when the test suite is unable to determine whether a result is a PASS or a FAIL. For certification you have to resolve each FIP case and upload your comments (in plain text) along with the test journals.</li>
      <li><b>Waived</b> means that the problem is waived and will not prevent the distro from being certified.</li>
    </ul>
  </li>
</ul>
<p align="right"><a href="#top">Back to top</a></p>

<a name="help"></a><h1>Help</h1>
<p align="justify">
Contains the description of the web-interface of the $DC_BRANCH Distribution Checker (the page you are reading now).
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="about"></a><h1>About</h1>
<p align="justify">
Contains the general information about $DC_BRANCH Distribution Checker: its version, license, etc.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="admin"></a><h1>Administration</h1>
<p align="justify">
This page is designed for performing administrative tasks. Please be careful doing anything on this page!
</p>
<p align="justify">
Currently the following items are present:
</p>
<ul>
  <li>
    <b>Status</b>
    <ul>
      <li><b>Server status:</b><br />Shows current status of the web-server and its PID. The button <b>Stop server</b> shuts the server down. Please note that you will not be able to use the web interface after that!</li>
      <li><b>Tests status:</b><br />Shows current status of the tests and PID of their parent process. The button <b>Stop tests</b> forcibly stops execution of the tests (it has the same meaning as the <b>Stop</b> button on the <a href="#exec"><b>Execution</b></a> page).</li>
      <li>The <b>View server log</b> link allows to open the web-server log in the browser.</li>
    </ul>
  </li>
  <li>
    <b>Server Configuration</b><br />
    This section allows to configure proxy servers Distribution Checker uses for external Internet connections.
    <ul>
      <li>
        <b>Use one configuration for both HTTP and FTP</b><br />
        If this checkbox is selected, the one proxy configuration will be used for connecting via both HTTP and FTP protocols. Otherwise they should be customized separately.
      </li>
      <li>
        <b>Hostname/Port</b><br />
        Here the address of the proxy server is specified. If the <b>Hostname</b> field is empty, the proxy will not be used at all.
      </li>
      <li>
        <b>Authentication</b><br />
        Select here the authentication method.
      </li>
      <li>
        <b>No tunnelling</b><br />
        If this checkbox is selected, only HTTP-like operations will be performed instead of tunnelling by means of the HTTP CONNECT request.
      </li>
      <li>
        <b>Username/Password</b><br />
        If the proxy requires username and password specify them here.<br />
        <a name="password_insecure"></a><span style="color: red;"><b>Warning!</b></span> Storing the password here is insecure: it is written in plain text in the configuration file and may also appear in the log files of test runs when the data are being downloaded.
      </li>
    </ul>
  </li>
</ul>
<p align="right"><a href="#top">Back to top</a></p>

<a name="troubleshooting"></a><h1>Troubleshooting</h1>
<ul>
<li>Some locales are required for libstdc++ test. That may turn into a problem for your distro. If that&rsquo;s the case, maybe the following solution for Debian will help you:<br />
<a href="http://people.debian.org/~taggart/lsb/tests.html" target="_blank">http://people.debian.org/~taggart/lsb/tests.html</a>
</li>

<li>In the case when the autotest couldn&rsquo;t find fonts, there is a workaround. First, find the font directory (see the files <font color="blue"><code>/etc/X11/xorg.conf</code></font> and <font color="blue"><code>/etc/X11/fs/config</code></font>). Also you may try the command<br />
<code>find / -name 75dpi</code><br />
to find all 75dpi font directories. Choose the appropriate font directory and make sure that the following subdirectories are present: &lsquo;misc&rsquo;, &lsquo;75dpi&rsquo;, &lsquo;100dpi&rsquo;.<br />
Autotest tries to find these subdirectories in the following locations:<br />
<ul>
<li><code>/usr/X11R6/lib/X11/fonts/</code></li>
<li><code>/usr/share/fonts/X11/</code></li>
<li><code>/usr/share/X11/fonts/</code></li>
<li><code>/usr/share/fonts/</code></li>
</ul>
Create symlinks to the found directories (misc, 75dpi, 100dpi) into one of the directories listed above so that autotest could find them next time.
</li>

<li>If you have no 100dpi fonts installed, you should install them using the tools provided by your distro.</li>
</ul>

<p align="justify">
Here are some of the possible errors and the ways of solving them.
</p>
<ul>

<li><b>Error: Couldn&rsquo;t find a required tool: &lsquo;&lt;some tool&gt;&rsquo;</b><br />
This error message occurs when you are missing a tool used by Distribution Checker. Please install the tool in the usual way for your distribution.
</li>

<li><b>Error: Failed to load problem database.</b><br />
&lsquo;problem_db2&rsquo; is a file that contains information about some known problems. Information in this file is used for the report creation. This file should be located at <font color="blue"><code>$SERVER_PARAM{'APP_DATA'}/problem_db/problem_db2</code></font>. Check that this file exists and can be read by root (Distribution Checker works as root). If the file doesn&rsquo;t exists, it is most likely that Distribution Checker wasn&rsquo;t installed correctly; reinstalling it should fix the problem. You could also download the latest problem database from here: <a href="http://ftp.linuxfoundation.org/pub/lsb/updates/dist-checker-data/problem_db2" target="_blank" style="white-space: nowrap;">http://ftp.linuxfoundation.org/pub/lsb/updates/dist-checker-data/problem_db2</a>.
</li>

<li><b>Error: Can&rsquo;t find the &lsquo;Xvfb&rsquo; tool required by Vsw4 test.</b><br />
If this error appears despite you have already installed <b>Xvfb</b>, please, restart the Distribution Checker server so that the PATH variable was updated.
</li>

</ul>

<p align="justify">
If you can&rsquo;t find a suitable solution, you can write to <a href="mailto:linux\@ispras.ru">linux\@ispras.ru</a>.
</p>
<p align="right"><a href="#top">Back to top</a></p>
DATA

print_footer();
